var prim = new Array ();

prim.next = function ()
{
    var candidate = this.length == 0 ? 1 : this [this.length - 1];
    var is_candidate, i;
    do
    {
        candidate++;
        is_candidate = true;
        i = 0;
        while (i < this.length && is_candidate)
            is_candidate = candidate % this [i++] != 0;
    } while (!is_candidate);
    this [this.length] = candidate;
}

prim.get = function (index)
{
    while (this.length <= index) this.next ();
    return this [index];
}

function maxnzs (remain, index, product)
{
    funccall++;
    if (index > maxdepth) maxdepth = index;

    if (remain <= 1) return product;
    var el = prim.get (index);
    if (remain < el) return 1;

    var newproduct = 1;
    var elval = 1;
    var newremain = remain;
    var mymax = 1;

    do
    {
        newproduct = maxnzs (newremain, index + 1, product * elval);
        if (newproduct > mymax) mymax = newproduct;
        elval *= el;
        newremain = remain - elval;
    } while (newremain >= 0);

    return mymax;
}

function numsort (a, b)
{
    return a - b;
}

function get_array (product)
{
    var index = 0;
    var control = 0;
    var outarr = new Array ();
    if (product == 1) outarr [0] = 1;
    else
        while (product != 1)
        {
            el = prim.get (index);
            arrel = 1;
            while (product % el == 0)
            {
                arrel *= el;
                product /= el;
            }
            if (arrel > 1)
            {
                outarr [outarr.length] = arrel;
                control += arrel;
            }
            index++;
        }
    outarr.sort (numsort);
    return outarr;
}

function easy_shift (adds)
{
    var outarr = new Array ();
    var el = 0;
    var lastel;
    for (var i = 0; i < adds.length; i++)
    {
        el++;
        lastel = el;
        for (var j = 1; j < adds [i]; j++) outarr [outarr.length] = ++el;
        outarr [outarr.length] = lastel;
    }
    return outarr;
}

function isPosInteger(inputVal) {
    //jsbiblia
inputStr = inputVal.toString()  ;
for (var i = 0; i < inputStr.length; i++) {
var oneChar = inputStr.charAt(i)    ;
if (oneChar < "0" || oneChar > "9") {
return false    ;
}
}
return true ;
}

function main (number)
{
    if (!isPosInteger (number) || number == 0) return 'error: main() - input must be positive integer';

    funccall = 0;
    maxdepth = 0;

    var product = maxnzs (number, 0, 1);
    var adds = get_array (product);
    var solution = easy_shift (adds);

    var outstr = 'number: ' + number + '\n\n';
    outstr += 'maxnzs: ' + product + '\n\n';
    outstr += 'elements: ' + adds.toString () + '\n\n';
    outstr += 'one solution: (' + solution.toString () + ')\n\n';
    outstr += 'stats: ' + funccall + ' calls of maxnzs ()' + '\n';
    outstr += 'maxdepth: ' + maxdepth;

    return outstr;
}